#include <napi.h>
#include <exception>
#include <iostream>

Napi::Value RunCallbackWithCall(const Napi::CallbackInfo& info) {
  Napi::Env env = info.Env();
  Napi::Function cb = info[0].As<Napi::Function>();
  return cb.Call({ Napi::String::New(env, "Hello, World!") });
}

Napi::Value RunCallbackWithMakeCallback(const Napi::CallbackInfo& info) {
  Napi::Env env = info.Env();
  Napi::Function cb = info[0].As<Napi::Function>();
  return cb.MakeCallback(env.Global(), { Napi::String::New(env, "Hello, World!") });
  /*try {
     return cb.MakeCallback(obj, { Napi::String::New(env, "Hello, World!") });
  } catch(std::exception &e) {
     std::cout << e.what() << std::endl;
    throw Napi::Error::New(info.Env(), "Error in RunCallbackWithMakeCallback");
  } */
}

Napi::Object Init(Napi::Env env, Napi::Object exports) {
  exports.Set(Napi::String::New(env, "runCallbackWithCall"),
              Napi::Function::New(env, RunCallbackWithCall));
  exports.Set(Napi::String::New(env, "runCallbackWithMakeCallback"),
              Napi::Function::New(env, RunCallbackWithMakeCallback));        
  return exports;
}

NODE_API_MODULE(NODE_GYP_MODULE_NAME, Init)
